"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
/* eslint-disable @typescript-eslint/no-unused-vars */
/**
 * @param command
 * @return {string | undefined} if the command is either relative or absolute file path, returns absolute filepath.
 */
var __isFilepath = function (command) {
    return;
};
var __isExecutable = function (abspath) {
    return new Promise(function (resolve) {
        fs.access(abspath, fs.constants.X_OK, function (err) { return resolve(err ? '' : abspath); });
    });
};
/**
 * @param {*} dir
 * @returns Promise<[]string>
 */
var __readDir = function (dir) {
    return new Promise(function (resolve) {
        fs.readdir(dir, function (err, files) {
            // if (err) console.error(err);
            // console.log(files);
            resolve(files || []);
        });
    });
};
var __findExecutableUnderDir = function (target, dir) {
    return __readDir(dir).then(function (files) {
        return Promise.all(files.filter(function (file) {
            if (path.basename(file) !== target)
                return false;
            return true;
        }).map(function (file) { return __isExecutable(path.join(dir, file)); }));
    });
};
var lookpath = function (command, opt) {
    if (opt === void 0) { opt = { path: [] }; }
    var directpath = __isFilepath(command);
    if (directpath) {
        return __isExecutable(directpath);
    }
    // TODO: Windows (PATHEXT)
    return Promise.all((process.env.PATH || '')
        .split(':')
        .concat(opt.path || [])
        .map(function (pathdir) { return __findExecutableUnderDir(command, pathdir); })).then(function (all) {
        var found = all
            .reduce(function (prev, curr) { return prev.concat(curr); }, [])
            .filter(function (abspath) { return !!abspath; })[0];
        return Promise.resolve(found);
    });
};
module.exports = lookpath;
